//*************************************************
// http://www.settorezero.com
//
// modulo: main.c
// autore: Bernardo Giovanni
// data:  27/12/11
// Il valore letto su AN1 viene riportato su una bargraph
// a 30 led pilotata da 4 shift register tipo 74HC595
// collegati in cascata
// picmicro: PIC16F877A
// clock: 20MHz
//
// SIETE PREGATI DI NON UTILIZZARE QUESTO CODICE
// PER LE VOSTRE PIETOSE RACCOLTE PUNTI
//*************************************************

#define _XTAL_FREQ 20000000
#include <htc.h>
__CONFIG (FOSC_HS & WDTE_OFF & PWRTE_ON & BOREN_OFF & LVP_OFF & CPD_OFF & WRT_OFF & DEBUG_OFF & CP_OFF);

#define DATA RD0		// RD0 da collegare a SIN della scheda
#define LATCH RD1		// RD1 da collegare a LAT
#define CLOCK RD2		// RD2 da collegare a CLK
#define BUTTON RB4		// pulsante per cambio modalit

#define MODE_DOT 0
#define MODE_BAR 1

unsigned int valore=0; // valore in uscita dal convertitore A/D
unsigned char mode=MODE_DOT; // modalit operativa: barra o punto
unsigned char conversion; // valore di conversione tra AD e numero led

void main(void);
void BarGraphSend(unsigned char value, char mo);
void settings(void);

void main(void)
        {
		settings();
		while(1)
			{
			if (!BUTTON) // rilevo il pulsante
				{
				mode^=1; // inverto la modalit (barra/punto)
				while(!BUTTON); // resto in attesa fino al rilascio del pulsante
				}
			__delay_us(20); // ritardo per Chold
			GO=1; // avvio conversione
			while(GO); // attesa fine conversione
			valore=ADRESL+(ADRESH<<8);
			// conversione tra valore letto dall'AD e numero del led (0 - 29)
			conversion=(valore*30)>>10; // shift a destra di 10 = divisione per 1024
			// richiamo la funzione che mi serializza i dati per gli shift register
			BarGraphSend(conversion,mode);
			}
		}
	
void BarGraphSend(unsigned char value, char mo)
	{
	unsigned char shift;
	unsigned long bar,v;
	bar=1ul<<value; // sposto il punto nella posizione "value"
	if (mo==MODE_BAR) // modalit barra? devo accendere i "punti" dallo zero fino al puntatore-1
		{
		unsigned char u;	
		for (u=0; u<value; u++)
			{
			bar |= 1ul<<u; // aggiungo altri punti
			}
		}
	// serializzazione dati
	for (shift=0; shift<32; shift++) // serializzo comunque 32bit anche se i led sono 30
		{
		v=bar&(0x80000000>>shift); // valore in uscita da MSB a LSB
		v?DATA=1:DATA=0;
		/*
		if (v) {DATA=1;}
			else {DATA=0;}
		*/
		CLOCK=1;
		CLOCK=0;
		}
	LATCH=1;
	LATCH=0;
	}
	
void settings(void)
	{
	// trimmer su AN1 (RA1)
	// BT1 su RB4
	TRISA=0b00101111;
	TRISB=0b00011111; 
    TRISC=0b00000000;
    TRISD=0b00000000;
    TRISE=0b00000111;
	nRBPU=0; // resistenze di pullup su portb
	ADCON0=0b10001001;
	ADCON1=0b10001110;
	}
	